题目:http://acm.hdu.edu.cn/showproblem.php?pid=3113
题意:给出一个正整数n,范围是[1,1000000],求出满足方程的一组整数解,要求x最小。
分析:这个方程与平方和不同的是,加号两边的任意一个可以为负数,所以直接枚举然后Hash就显得不好做了。那么我用一种
比较有效的方式解决。
我们知道,那么我们这样来做,首先把n的所有因子找出来,枚举所有的因子。
假设当前的因子为,那么令,即得到:
在这里其实还有一种情况就是:
你会发现这种情况根本没有解,所以不予考虑。
对上面的方程组消去y,我们得到: ,那么得到:
那么我们就只需要在枚举因子的过程中,判断是否为完全平方数和,并且记录最
小的x以及对应的y。
#include <iostream>
#include <string.h>
#include <algorithm>
#include <stdio.h>
#include <math.h>
using namespace std;
const int N = 1000005;
const int INF = 1 << 30;
const int M = 1005;
bool prime[N];
int p[N];
int pri[M],num[M];
int arr[M];
int k,cnt,ct;
void isprime()
{
k = 0;
memset(prime,true,sizeof(prime));
for(int i=2;i<N;i++)
{
if(prime[i])
{
p[k++] = i;
for(int j=i+i;j<N;j+=i)
prime[j] = false;
}
}
}
void Divide(int n)
{
cnt = 0;
int t = (int)sqrt(1.0*n);
for(int i=0;p[i]<=t;i++)
{
if(n%p[i]==0)
{
int a = 0;
pri[cnt] = p[i];
while(n%p[i]==0)
{
n /= p[i];
a++;
}
num[cnt] = a;
cnt++;
}
}
if(n > 1)
{
pri[cnt] = n;
num[cnt] = 1;
cnt++;
}
}
void dfs(int dept,int product = 1)
{
if(dept == cnt)
{
arr[ct++] = product;
return;
}
for(int i=0;i<=num[dept];i++)
{
dfs(dept+1,product);
product *= pri[dept];
}
}
void Work(int n)
{
ct = 0;
Divide(n);
dfs(0,1);
sort(arr,arr+ct);
int ctt = 0;
int ansx = INF;
int ansy = INF;
int tmpx = 0;
int tmpy = 0;
for(int i=0;i<ct;i++)
{
int t = n / arr[i] * 12 - 3 * arr[i] * arr[i];
if(t >= 0)
{
int tmp = (int)sqrt(t * 1.0);
if(tmp * tmp == t)
{
if((3*arr[i] - tmp)%6==0)
{
ctt++;
tmpx = (3*arr[i] - tmp) / 6;
if(tmpx < ansx)
{
ansx = tmpx;
ansy = arr[i] - tmpx;
}
}
if((3*arr[i] + tmp)%6==0)
{
ctt++;
tmpx = (3*arr[i] + tmp) / 6;
if(tmpx < ansx)
{
ansx = tmpx;
ansy = arr[i] - tmpx;
}
}
}
}
}
if(ctt == 0) puts("Impossible");
else printf("%d %d\n",ansx,ansy);
}
int main()
{
int n;
isprime();
while(~scanf("%d",&n))
{
if(n == 0) break;
Work(n);
}
return 0;
}